<?php

include_once('db.php');
include_once('general.php');

// Get part after script name
$args = get_arguments();


// Args are tricky for this one...
// Certain types mean change quantities in the session.
$active = 0;
if( $_POST['action'] == 'change' ) {
	$count = get_int($_POST['count']) or 0;
	// The values are in catN, itemN, qtyN
	for($i=0;$i<$count;++$i) {
		$cat = get_int($_POST["cat$i"]);
		$item = get_int($_POST["item$i"]);
		$qty = get_int( $_POST["qty$i"] + 0 );
		if( !(isset($cat)&&isset($item)&&isset($qty)) )
			error("Bad cart change","The cart change request was " .
				"incorrectly formed.");
		change_in_cart($cat,$item,$qty);
	}
}
elseif( count($args) == 0 ) {
	// do nothing
}
elseif( count($args) == 3 ) {
	// add or remove
	$action = $args[0];
	if($action != 'add' and $action != 'remove')
		unset($action);
	$cat = get_int($args[1]);
	$item = get_int($args[2]);

	if( !(isset($action)&&isset($cat)&&isset($item)) )
		error("Bad cart change","The link that led you here is invalid (wrong arguments).");

	if($action == 'add')
		add_to_cart($cat,$item);
	else
		remove_from_cart($cat,$item);
}
else
	error("Bad cart link","The link that led you here is invalid (wrong number of arguments).");

// Looks good.
$db = dbconnect();

// explode('-',$key,2) should return the pieces of an item in hyph-form.

// We'll use a first query to clean up nonexistent items
// and items whose quantities are over cap.
verify_cart_values($db);

// Now, the cart content should be mostly cleaned up.
// Seek the item info to display.
$cart_empty = 0;
if( isset($_SESSION['cart']) and count($_SESSION['cart']) > 0 ) {
	// Once again, the items are the keys of this array.
	$query = array();
	{
		foreach(array_keys($_SESSION['cart']) as $key) {
			// Split the key
			list($cat,$item) = explode('-',$key,2);
			$cat = get_int($cat) or 0;
			$item = get_int($item) or 0;
			// add to the where clause
			$query[] = sprintf("(p.category_id='%s' and p.product_id='%s')",
				dbquote($cat,$db),dbquote($item,$db) );
		}
	}
	// Assemble the query
	$query = "select p.category_id,p.product_id,p.name,p.quantity,u.name
		from product p, unit u
		where u.unit_id = p.unit_id
		and (" . implode(" or ",$query) . ")
		order by p.name";

	$r = dbquery($query,$db);
} else {
	$cart_empty = 1;
}

$page_title = "Cart";

class page {

function body() {
	global $r, $cart_empty;



	?>
	<h1>Your Cart</h1>

	<div>
<?php
	if( $cart_empty || mysql_num_rows($r) == 0 ) {
		?><p>There are no items in the cart.</p><?php
	}
	else {
		?>
		<div>
		<?php print "<form action='" . base_loc("cart") . "' ".
			"method='post' >"; ?>
		<input type="hidden" name="action" value="change" />
		<?php print "<input type='hidden' name='count' value='" .
			mysql_num_rows($r) . "' />" ?>
		<table>
		<tr>
			<th colspan="2">Product</th>
			<th>Stock</th>
			<th>In cart</th>
		</tr>
		<?php

		$iter = 0;

		while(list($cid,$pid,$pname,$qty,$unit)=mysql_fetch_array($r)) {
			// Print each item as a table row
			$loc = item_loc($cid,$pid);
			$img = image_loc($cid,$pid,1);
			$pname = htmlspecialchars($pname);
			$link = "<a href='$loc'>";
			?>
			<tr>
			<td><?php print "$link<img src='$img' alt='$pname' /></a>" ?></td>
			<td><?php print "$link$pname</a>" ?></td>
			<td><?php
				// None left?
				if($qty == 0) {
					print "Sold Out";
				}
				else {
					// We have some...
					$qtywords = "$qty $unit";
					// But not many...
					if($qty < 10) {
						print "Hurry! Only $qtywords left in stock!";
					} else {
						// Or plenty.
						print $qtywords;
					}
				}
			?></td>
			<td><?php
				// Form information in this cell.
				$h = "<input type='hidden' name=";
				print "$h'cat$iter' value='$cid' />";
				print "$h'item$iter' value='$pid' />";
				$incart = min(in_cart($cid,$pid),$qty);
				print "<input type='text' name='qty$iter' size='3' value='$incart' />";
				print "$unit";
			?></td>
			</tr><?php

			// Increment counter.
			++$iter;
		}

		?>
		<tr><td colspan="4">
		<input type="submit" value="Update totals" />
		</td></tr>
		</table></form></div>

		<p><?php print '<a href="' . base_loc("checkout") . '">Proceed to checkout</a>'; ?></p>
		<?php

	}


?>
	</div>


	<?php
}

}

$page = new page();
include_once('template.php');

?>
