<?php

include_once('db.php');
include_once('general.php');

// Get part after script name
$args = get_arguments();

// The argument has to be two integers (category and item) 
if( count($args) != 2 )
	error("Bad item","The link that led you here is invalid (wrong number of arguments).");
else {
	$cat = get_int($args[0]);
	$item = get_int($args[1]);
}

// Was it an integer?
if( !isset($cat) or !isset($item) )
	error("Bad item","The link that led you here is invalid (arguments must be integers).");

// Looks good.  Try to grab something with it.
$db = dbconnect();

// Get the item data this time.
$q = sprintf("select c.name,p.name,p.quantity,u.name from
	category c, product p, unit u
	where p.category_id = '%s'
	and p.product_id = '%s'
	and c.category_id = p.category_id
	and u.unit_id = p.unit_id
	limit 1",
	dbquote($cat,$db),
	dbquote($item,$db) );

$r = dbquery($q,$db);

if(mysql_num_rows($r) != 1)
	error("Bad item","This item does not exist; it may have been removed from our inventory.");

// The category exists if we're here.
list($category_name,$product_name,$quantity,$unit) = mysql_fetch_array($r);
$page_title = $product_name;

class page {

function body() {
	global $cat,$item,$category_name,$product_name,$quantity,$unit;

	// Show the listing.

	?>
	<h1><?php print htmlspecialchars($product_name) ?></h1>
	<h2><?php
		print "<a href='" . category_loc($cat) . "'>";
		print "Back to " . htmlspecialchars($category_name) . "</a>" ?></h2>

	<div>
	<?php
	print "<div><img src='" . image_loc($cat,$item,0) . "' alt=\"" .
		htmlspecialchars($product_name) . "\" /></div>";
	?>
	<ul>
	<li><strong>Stock:</strong> <?php
		if($quantity == 0) {
			// none left
			print "Sold out";
		} else {
			$qtyname = "$quantity $unit";
			if($quantity < 10) {
				print "Hurry! Only $qtyname left in stock!";
			} else {
				print $qtyname;
			}
		}
	?></li>
	<?php // only do the cart part if there's inventory
	if($quantity > 0) {
	?>
		<li><strong>In cart:</strong> <?php
			// We're going to cap this to whatever is available.
			$cartqty = in_cart($cat,$item);
			$cartqty = min($cartqty,$quantity);
			$cartqtyname = "$cartqty $unit";

			if($cartqty == 0) {
				print "None. <a href='" . add_loc($cat,$item) . "'>Add to cart</a>";
			} else {
				print "$cartqtyname. <a href='" . remove_loc($cat,$item) .
					"'>Remove all from cart</a> <a href='" . base_loc("cart") .
					"'>View cart</a>";
			}
		?></li>
	<?php
	}
	?>
	</ul>
	</div>


	<?php
}

}

$page = new page();
include_once('template.php');

?>
