<?php

/*

This template file has an interesting sort of function-pointerish
design to it.  The particular application (such as category, checkout,
et c.) decides what title to give the page by assigning the variable
$page_title.  But the main body of the page is a little too much to
store in a string without guilt.  Instead, the application defines a
singleton class which defines a single method, body().  Near the end,
it instantiates that class to the global $page, then includes this
file to render.

The reason it's done this way instead of with normal functions lies
in the way error() (see general.php) is implemented.  It includes
error.php, which defines its own class to do the same thing, then
includes this page.  This might not be possible with regular functions
because, last I checked, you can't have more than one function with
the same name in a program.

*/

?>
<html>
<head>
<link rel="stylesheet" href="styles.css" type="text/css" />
<?php
	print "<link rel='stylesheet' href='" . base_loc("styles") .
		"' type='text/css' />";
?>
<title><?php

if( isset($page_title) ) {
	print htmlspecialchars($page_title);
	print " - ";
}

print "bZar";

?></title>

</head>

<body>

<?php $page->body(); ?>

<div id="footer">
<?php
include_once('general.php');
print "<a href='$PROGRAM_BASE'>Category Index</a> ";
print "<a href='$PROGRAM_BASE" . "cart'>View Cart</a>";
?>
</div>

</body>
</html>
